package t3SampleTestProducts;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Iterator;
import java.util.TreeSet;

public class PremiumProduct extends Product{
	// Problem 1a
	public PremiumProduct(int id, int inventory) {
		super(id, inventory);
		if(id>=9000 || inventory<0) {
			System.out.println("\nProblem 1a");
			throw new IllegalArgumentException("id or inv invalid");
		}
	}

	@Override
	public String toString() {
		return "PremiumProduct: id=" + getId() + ", inventory=" + getInventory();
	}

	public static void main(String[] args) throws CloneNotSupportedException {
		// Problem 1b
		System.out.println("\nProblem 1b");
		PremiumProduct pp;
		try {
			pp = new PremiumProduct(89, -30);
			System.out.println(pp);
		}
		catch(IllegalArgumentException e) {
			System.out.println(e);
		}
		
		// Problem 2b
		System.out.println("\nProblem 2b");
		ArrayList<Product> products = new ArrayList<>(Arrays.asList(new Product(20,30), new PremiumProduct(8,22), 
				new Product(15,99)));
		System.out.println("Before Sort:\n" + products);
		// Problem 2b - Answer below
		Collections.sort(products, new ProductIdComparator());
		// Problem 2b - Answer above
		System.out.println("After Sort:\n" + products);
		
		// Problem 2c
		System.out.println("\nProblem 2c");
		// Problem 2c - Answer below
		TreeSet<Product> productsOrdered = new TreeSet<>(new ProductIdComparator());
		// Problem 2c - Answer above
		products = new ArrayList<>(Arrays.asList(new Product(20,30), new PremiumProduct(8,22), 
				new Product(15,99)));
		productsOrdered.addAll(products);
		System.out.println("After Addition:\n" + productsOrdered);
		
		// Test Prob 3
		System.out.println("\nProblem 3");
		products = new ArrayList<>(Arrays.asList(new Product(20,30), new PremiumProduct(8,22), 
				new Product(15,99), new PremiumProduct(88,75)));
		System.out.println("products, before remHigh(): " + products);
		ArrayList<Product> highInventory = remHigh(products, 60);
		System.out.println("products, after remHigh(): " + products);
		System.out.println("highInventory, after remHigh(): " + highInventory);
		
		
		

	}
	
	// Problem 3
	public static ArrayList<Product> remHigh(ArrayList<Product> products, int max) {
		ArrayList<Product> highInventory = new ArrayList<>();
		Iterator<Product> iter = products.iterator();
		while(iter.hasNext()) {
			Product p = iter.next();
			if(p.getInventory() > max) {
				iter.remove();
				highInventory.add(p);
			}
		}
		return highInventory;
	}

}
